Failure to load PostGIS raster without bands

2018-02-24 01:18 PM - Paolo Cavallini

Status: Closed

Priority: High

Assignee: Alessandro Pasotti

Category: DB Manager

Affected QGIS version:3.3(master) Regression?: Yes

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: worksforme

Crashes QGIS or corrupts data:No Copied to github as #: 26095

Description

List of tables, inlcuding rasters, are correctly displayed in DB Manager. When double clicking, loading fails with the message:

Cannot open GDAL dataset PG: dbname=

Couldn't establish database connection

In the dialog, username and password are requested.

Vectors are loaded correctly.

To replicate:

-- create an empty table

CREATE TABLE public.test_raster

(

  rid integer,

  rast raster,

  CONSTRAINT enforce_height_rast CHECK (st_height(rast) = ANY

(ARRAY[100, 24])),

  CONSTRAINT enforce_width_rast CHECK (st_width(rast) = ANY (ARRAY[100,

24])),

  CONSTRAINT enforce_srid_rast CHECK (st_srid(rast) = 4326)

);

-- create an empty raster

INSERT INTO test_raster(rid,rast)

VALUES(1, ST_MakeEmptyRaster( 100, 100, 0.0005, 0.0005, 1, 1, 0, 0, 4326) );

-- add primary key

ALTER TABLE test_raster ADD CONSTRAINT test_pkey PRIMARY KEY (rid);

History

#1 - 2018-02-24 05:18 PM - Giovanni Manghi

- Priority changed from Normal to High

#2 - 2018-09-05 03:44 PM - Giovanni Manghi
- Affected QGIS version changed from 3.0.0 to 3.3(master)

#3 - 2018-09-24 02:09 PM - Alessandro Pasotti

- Assignee set to Alessandro Pasotti

#4 - 2018-09-24 02:23 PM - Alessandro Pasotti

- Status changed from Open to Feedback

I could not reproduce exactly the same issue as I get a different message from DB manager: "Cannot get GDAL raster band:"

As reported by https://postgis.net/docs/RT_ST_MakeEmptyRaster.html , a raster with 0 bands is created by ST_MakeEmptyRaster, QGIS needs at least

one band so this error makes sense.

The error you mention about the connection appears to be different and I cannot reproduce it.

#5 - 2018-09-24 02:24 PM - Alessandro Pasotti

- Subject changed from Failure to load PostGIS raster to Failure to load PostGIS raster without bands

#6 - 2018-09-24 02:50 PM - Giovanni Manghi

The error you mention about the connection appears to be different and I cannot reproduce it.

something seems to have changed(?). Now I see the same as you, but a few days ago I have confirmed what described by the reporter.

#7 - 2018-09-25 08:01 AM - Alessandro Pasotti

In any event, the raster generated with ST_MakeEmptyRaster has no bands and will never be opened by QGIS.

Can we close this?

#8 - 2018-09-27 09:50 AM - Paolo Cavallini

- Resolution set to worksforme

- Status changed from Feedback to Closed

Thanks

2025-04-27 2/2

https://postgis.net/docs/RT_ST_MakeEmptyRaster.html

